package checkers.inference

import javax.lang.model.element.AnnotationMirror
abstract class ConstraintSolver(val variables: List[Variable],
  val combvariables: List[CombVariable],
  val constraints: List[Constraint],
  val weights: List[WeightInfo]) {

  def solve(): Option[Map[AbstractVariable, AnnotationMirror]]

  // Return formatted timing information
  def timing: String
}
